require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_ELF_H_)) {
    eval 'sub _MACHINE_ELF_H_ () {1;}' unless defined(&_MACHINE_ELF_H_);
    require 'sys/elf32.ph';
    require 'sys/elf64.ph';
    unless(defined(&__ELF_WORD_SIZE)) {
	eval 'sub __ELF_WORD_SIZE () {64;}' unless defined(&__ELF_WORD_SIZE);
    }
    require 'sys/elf_generic.ph';
    eval 'sub ELF_ARCH () { &EM_AARCH64;}' unless defined(&ELF_ARCH);
    eval 'sub ELF_MACHINE_OK {
        my($x) = @_;
	    eval q((($x) == ( &ELF_ARCH)));
    }' unless defined(&ELF_MACHINE_OK);
    eval 'sub AT_NULL () {0;}' unless defined(&AT_NULL);
    eval 'sub AT_IGNORE () {1;}' unless defined(&AT_IGNORE);
    eval 'sub AT_EXECFD () {2;}' unless defined(&AT_EXECFD);
    eval 'sub AT_PHDR () {3;}' unless defined(&AT_PHDR);
    eval 'sub AT_PHENT () {4;}' unless defined(&AT_PHENT);
    eval 'sub AT_PHNUM () {5;}' unless defined(&AT_PHNUM);
    eval 'sub AT_PAGESZ () {6;}' unless defined(&AT_PAGESZ);
    eval 'sub AT_BASE () {7;}' unless defined(&AT_BASE);
    eval 'sub AT_FLAGS () {8;}' unless defined(&AT_FLAGS);
    eval 'sub AT_ENTRY () {9;}' unless defined(&AT_ENTRY);
    eval 'sub AT_NOTELF () {10;}' unless defined(&AT_NOTELF);
    eval 'sub AT_UID () {11;}' unless defined(&AT_UID);
    eval 'sub AT_EUID () {12;}' unless defined(&AT_EUID);
    eval 'sub AT_GID () {13;}' unless defined(&AT_GID);
    eval 'sub AT_EGID () {14;}' unless defined(&AT_EGID);
    eval 'sub AT_EXECPATH () {15;}' unless defined(&AT_EXECPATH);
    eval 'sub AT_CANARY () {16;}' unless defined(&AT_CANARY);
    eval 'sub AT_CANARYLEN () {17;}' unless defined(&AT_CANARYLEN);
    eval 'sub AT_OSRELDATE () {18;}' unless defined(&AT_OSRELDATE);
    eval 'sub AT_NCPUS () {19;}' unless defined(&AT_NCPUS);
    eval 'sub AT_PAGESIZES () {20;}' unless defined(&AT_PAGESIZES);
    eval 'sub AT_PAGESIZESLEN () {21;}' unless defined(&AT_PAGESIZESLEN);
    eval 'sub AT_TIMEKEEP () {22;}' unless defined(&AT_TIMEKEEP);
    eval 'sub AT_STACKPROT () {23;}' unless defined(&AT_STACKPROT);
    eval 'sub AT_EHDRFLAGS () {24;}' unless defined(&AT_EHDRFLAGS);
    eval 'sub AT_HWCAP () {25;}' unless defined(&AT_HWCAP);
    eval 'sub AT_HWCAP2 () {26;}' unless defined(&AT_HWCAP2);
    eval 'sub AT_COUNT () {27;}' unless defined(&AT_COUNT);
    if((defined(&__ELF_WORD_SIZE) ? &__ELF_WORD_SIZE : undef) == 64) {
	eval 'sub ELF_TARG_CLASS () { &ELFCLASS64;}' unless defined(&ELF_TARG_CLASS);
	eval 'sub ELF_TARG_DATA () { &ELFDATA2LSB;}' unless defined(&ELF_TARG_DATA);
	eval 'sub ELF_TARG_MACH () { &EM_AARCH64;}' unless defined(&ELF_TARG_MACH);
	eval 'sub ELF_TARG_VER () {1;}' unless defined(&ELF_TARG_VER);
    } else {
	eval 'sub ELF_TARG_CLASS () { &ELFCLASS32;}' unless defined(&ELF_TARG_CLASS);
	eval 'sub ELF_TARG_DATA () { &ELFDATA2LSB;}' unless defined(&ELF_TARG_DATA);
	eval 'sub ELF_TARG_MACH () { &EM_ARM;}' unless defined(&ELF_TARG_MACH);
	eval 'sub ELF_TARG_VER () {1;}' unless defined(&ELF_TARG_VER);
    }
    eval 'sub ET_DYN_LOAD_ADDR () {0x100000;}' unless defined(&ET_DYN_LOAD_ADDR);
    eval 'sub HWCAP_FP () {0x1;}' unless defined(&HWCAP_FP);
    eval 'sub HWCAP_ASIMD () {0x2;}' unless defined(&HWCAP_ASIMD);
    eval 'sub HWCAP_EVTSTRM () {0x4;}' unless defined(&HWCAP_EVTSTRM);
    eval 'sub HWCAP_AES () {0x8;}' unless defined(&HWCAP_AES);
    eval 'sub HWCAP_PMULL () {0x10;}' unless defined(&HWCAP_PMULL);
    eval 'sub HWCAP_SHA1 () {0x20;}' unless defined(&HWCAP_SHA1);
    eval 'sub HWCAP_SHA2 () {0x40;}' unless defined(&HWCAP_SHA2);
    eval 'sub HWCAP_CRC32 () {0x80;}' unless defined(&HWCAP_CRC32);
    eval 'sub HWCAP_ATOMICS () {0x100;}' unless defined(&HWCAP_ATOMICS);
    eval 'sub HWCAP_FPHP () {0x200;}' unless defined(&HWCAP_FPHP);
    eval 'sub HWCAP_ASIMDHP () {0x400;}' unless defined(&HWCAP_ASIMDHP);
    eval 'sub HWCAP_CPUID () {0x800;}' unless defined(&HWCAP_CPUID);
    eval 'sub HWCAP_ASIMDRDM () {0x1000;}' unless defined(&HWCAP_ASIMDRDM);
    eval 'sub HWCAP_JSCVT () {0x2000;}' unless defined(&HWCAP_JSCVT);
    eval 'sub HWCAP_FCMA () {0x4000;}' unless defined(&HWCAP_FCMA);
    eval 'sub HWCAP_LRCPC () {0x8000;}' unless defined(&HWCAP_LRCPC);
    eval 'sub HWCAP_DCPOP () {0x10000;}' unless defined(&HWCAP_DCPOP);
    eval 'sub HWCAP_SHA3 () {0x20000;}' unless defined(&HWCAP_SHA3);
    eval 'sub HWCAP_SM3 () {0x40000;}' unless defined(&HWCAP_SM3);
    eval 'sub HWCAP_SM4 () {0x80000;}' unless defined(&HWCAP_SM4);
    eval 'sub HWCAP_ASIMDDP () {0x100000;}' unless defined(&HWCAP_ASIMDDP);
    eval 'sub HWCAP_SHA512 () {0x200000;}' unless defined(&HWCAP_SHA512);
    eval 'sub HWCAP_SVE () {0x400000;}' unless defined(&HWCAP_SVE);
    eval 'sub HWCAP_ASIMDFHM () {0x800000;}' unless defined(&HWCAP_ASIMDFHM);
    eval 'sub HWCAP_DIT () {0x1000000;}' unless defined(&HWCAP_DIT);
    eval 'sub HWCAP_USCAT () {0x2000000;}' unless defined(&HWCAP_USCAT);
    eval 'sub HWCAP_ILRCPC () {0x4000000;}' unless defined(&HWCAP_ILRCPC);
    eval 'sub HWCAP_FLAGM () {0x8000000;}' unless defined(&HWCAP_FLAGM);
    eval 'sub HWCAP_SSBS () {0x10000000;}' unless defined(&HWCAP_SSBS);
    eval 'sub HWCAP_SB () {0x20000000;}' unless defined(&HWCAP_SB);
    eval 'sub HWCAP_PACA () {0x40000000;}' unless defined(&HWCAP_PACA);
    eval 'sub HWCAP_PACG () {0x80000000;}' unless defined(&HWCAP_PACG);
    eval 'sub HWCAP2_DCPODP () {0x1;}' unless defined(&HWCAP2_DCPODP);
    eval 'sub HWCAP2_SVE2 () {0x2;}' unless defined(&HWCAP2_SVE2);
    eval 'sub HWCAP2_SVEAES () {0x4;}' unless defined(&HWCAP2_SVEAES);
    eval 'sub HWCAP2_SVEPMULL () {0x8;}' unless defined(&HWCAP2_SVEPMULL);
    eval 'sub HWCAP2_SVEBITPERM () {0x10;}' unless defined(&HWCAP2_SVEBITPERM);
    eval 'sub HWCAP2_SVESHA3 () {0x20;}' unless defined(&HWCAP2_SVESHA3);
    eval 'sub HWCAP2_SVESM4 () {0x40;}' unless defined(&HWCAP2_SVESM4);
    eval 'sub HWCAP2_FLAGM2 () {0x80;}' unless defined(&HWCAP2_FLAGM2);
    eval 'sub HWCAP2_FRINT () {0x100;}' unless defined(&HWCAP2_FRINT);
    eval 'sub HWCAP2_SVEI8MM () {0x200;}' unless defined(&HWCAP2_SVEI8MM);
    eval 'sub HWCAP2_SVEF32MM () {0x400;}' unless defined(&HWCAP2_SVEF32MM);
    eval 'sub HWCAP2_SVEF64MM () {0x800;}' unless defined(&HWCAP2_SVEF64MM);
    eval 'sub HWCAP2_SVEBF16 () {0x1000;}' unless defined(&HWCAP2_SVEBF16);
    eval 'sub HWCAP2_I8MM () {0x2000;}' unless defined(&HWCAP2_I8MM);
    eval 'sub HWCAP2_BF16 () {0x4000;}' unless defined(&HWCAP2_BF16);
    eval 'sub HWCAP2_DGH () {0x8000;}' unless defined(&HWCAP2_DGH);
    eval 'sub HWCAP2_RNG () {0x10000;}' unless defined(&HWCAP2_RNG);
    eval 'sub HWCAP2_BTI () {0x20000;}' unless defined(&HWCAP2_BTI);
}
1;
