require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_PMAP_H_)) {
    eval 'sub _MACHINE_PMAP_H_ () {1;}' unless defined(&_MACHINE_PMAP_H_);
    require 'machine/pte.ph';
    unless(defined(&LOCORE)) {
	require 'sys/queue.ph';
	require 'sys/_lock.ph';
	require 'sys/_mutex.ph';
	require 'vm/_vm_radix.ph';
	if(defined(&_KERNEL)) {
	    eval 'sub vtophys {
	        my($va) = @_;
    		eval q( &pmap_kextract(( &vm_offset_t)($va)));
	    }' unless defined(&vtophys);
	}
	eval 'sub pmap_page_get_memattr {
	    my($m) = @_;
    	    eval q((($m)-> ($md->{pv_memattr})));
	}' unless defined(&pmap_page_get_memattr);
	eval 'sub pmap_page_is_write_mapped {
	    my($m) = @_;
    	    eval q(((($m)-> &aflags &  &PGA_WRITEABLE) != 0));
	}' unless defined(&pmap_page_is_write_mapped);
	eval 'sub _NPCM () {3;}' unless defined(&_NPCM);
	eval 'sub _NPCPV () {168;}' unless defined(&_NPCPV);
	eval 'sub PV_CHUNK_HEADER () { &pmap_t  &pc_pmap;  &TAILQ_ENTRY( &pv_chunk)  &pc_list;  &uint64_t  $pc_map[ &_NPCM];  &TAILQ_ENTRY( &pv_chunk)  &pc_lru;;}' unless defined(&PV_CHUNK_HEADER);
	if(defined(&_KERNEL)) {
	    eval 'sub kernel_pmap () {( &kernel_pmap_store);}' unless defined(&kernel_pmap);
	    eval 'sub pmap_kernel () {
	        eval q( &kernel_pmap);
	    }' unless defined(&pmap_kernel);
	    eval 'sub PMAP_ASSERT_LOCKED {
	        my($pmap) = @_;
    		eval q( &mtx_assert(($pmap)-> &pm_mtx,  &MA_OWNED));
	    }' unless defined(&PMAP_ASSERT_LOCKED);
	    eval 'sub PMAP_LOCK {
	        my($pmap) = @_;
    		eval q( &mtx_lock(($pmap)-> &pm_mtx));
	    }' unless defined(&PMAP_LOCK);
	    eval 'sub PMAP_LOCK_ASSERT {
	        my($pmap, $type) = @_;
    		eval q( &mtx_assert(($pmap)-> &pm_mtx, ($type)));
	    }' unless defined(&PMAP_LOCK_ASSERT);
	    eval 'sub PMAP_LOCK_DESTROY {
	        my($pmap) = @_;
    		eval q( &mtx_destroy(($pmap)-> &pm_mtx));
	    }' unless defined(&PMAP_LOCK_DESTROY);
	    eval 'sub PMAP_LOCK_INIT {
	        my($pmap) = @_;
    		eval q( &mtx_init(($pmap)-> &pm_mtx, \\"pmap\\",  &NULL,  &MTX_DEF |  &MTX_DUPOK));
	    }' unless defined(&PMAP_LOCK_INIT);
	    eval 'sub PMAP_OWNED {
	        my($pmap) = @_;
    		eval q( &mtx_owned(($pmap)-> &pm_mtx));
	    }' unless defined(&PMAP_OWNED);
	    eval 'sub PMAP_MTX {
	        my($pmap) = @_;
    		eval q((($pmap)-> &pm_mtx));
	    }' unless defined(&PMAP_MTX);
	    eval 'sub PMAP_TRYLOCK {
	        my($pmap) = @_;
    		eval q( &mtx_trylock(($pmap)-> &pm_mtx));
	    }' unless defined(&PMAP_TRYLOCK);
	    eval 'sub PMAP_UNLOCK {
	        my($pmap) = @_;
    		eval q( &mtx_unlock(($pmap)-> &pm_mtx));
	    }' unless defined(&PMAP_UNLOCK);
	    eval 'sub PHYS_AVAIL_SIZE () {32;}' unless defined(&PHYS_AVAIL_SIZE);
	    eval 'sub L1_MAPPABLE_P {
	        my($va, $pa, $size) = @_;
    		eval q((((($va) | ($pa)) &  &L1_OFFSET) == 0 && ($size) >=  &L1_SIZE));
	    }' unless defined(&L1_MAPPABLE_P);
	    eval 'sub pmap_vmspace_copy {
	        my($__unused,$__unused) = @_;
    		eval q({ (0); });
	    }' unless defined(&pmap_vmspace_copy);
	}
    }
}
1;
